// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "gamelist.h"
#include "ChildView.h"
#include "GameDialog.h"
#include "InputDialog.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define IDC_LISTBOX  100
#define IDC_COMMENT  101
#define IDC_LISTBOX2 103
#define IDC_URLBUTTON 104 


/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
 GamesCounter=0;
 WasChanged=false;
 HasName=false;
 OpenFile="Bezjmena";
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_COMMAND(ID_NEWITEM, OnNewitem)
	ON_COMMAND(ID_EDITITEM, OnEdititem)
	ON_COMMAND(ID_DELETEITEM, OnDeleteitem)
	ON_COMMAND(ID_NEWLIST, OnNewlist)
	ON_COMMAND(ID_SAVELIST, OnFileSave)
	ON_COMMAND(ID_OPENLIST, OnOpenlist)
	ON_COMMAND(ID_SAVEASLIST, OnSaveaslist)
	ON_COMMAND(ID_FINDITEM, OnFinditem)
	ON_COMMAND(ID_EXPORT, OnExport)
	ON_BN_CLICKED(IDC_URLBUTTON,OnGotoURL)
	ON_COMMAND(ID_PRINT, OnPrint)
	//}}AFX_MSG_MAP
	ON_LBN_SELCHANGE(IDC_LISTBOX,OnLBNSelChange)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}


int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	CRect rect(0,0,300,310);
	GameListBox.CreateEx (WS_EX_CLIENTEDGE, _T ("LISTBOX"), NULL,
    WS_CHILD | WS_VISIBLE | LBS_STANDARD, rect, this, IDC_LISTBOX);	
	rect.SetRect(310,5,600,23);
	st_Jmeno.Create("",WS_CHILD | WS_VISIBLE,rect,this);
	st_Jmeno.SetTextColor(RGB(0,0,255));
	st_Jmeno.SetBkColor(RGB(255,255,255));
    rect.SetRect(310,25,400,43);
	st_RokLabel.Create("Rok vroby:",WS_CHILD | WS_VISIBLE,rect,this);
	st_RokLabel.SetBkColor(RGB(255,255,255));
	rect.SetRect(405,25,600,43);
	st_Rok.Create("",WS_CHILD | WS_VISIBLE,rect,this);
	st_Rok.SetBkColor(RGB(255,255,255));
	rect.SetRect(310,45,400,58);
	st_PocetCDLabel.Create("Poet CD:",WS_CHILD | WS_VISIBLE,rect,this);
	st_PocetCDLabel.SetBkColor(RGB(255,255,255));
	rect.SetRect(405,45,600,58);
	st_PocetCD.Create("",WS_CHILD | WS_VISIBLE,rect,this);
	st_PocetCD.SetBkColor(RGB(255,255,255));
	rect.SetRect(310,63,400,81);
	st_StylLabel.Create("Styl hry:",WS_CHILD | WS_VISIBLE,rect,this);
	st_StylLabel.SetBkColor(RGB(255,255,255));
	rect.SetRect(410,63,600,81);
	st_Styl.Create("",WS_CHILD | WS_VISIBLE,rect,this);
	st_Styl.SetBkColor(RGB(255,255,255));
	rect.SetRect(310,90,570,165);
	et_Komentar.Create(WS_BORDER | WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_READONLY ,rect,this,IDC_COMMENT);
	et_Komentar.SetWindowText("");
	rect.SetRect(310,190,570,290);
	LinksListBox.CreateEx (WS_EX_CLIENTEDGE, _T ("LISTBOX"), NULL,
    WS_CHILD | WS_VISIBLE | LBS_STANDARD, rect, this, IDC_LISTBOX2);	
	rect.SetRect(390,282,470,305);
	URLButton.Create("Jdi na URL",WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON,rect,this,IDC_URLBUTTON);   
	return 0;
}

void CChildView::OnNewitem() 
{
		// TODO: Add your command handler code here
 int i,j;
 CGameDialog Dlg;
 CArray<CLink,CLink&> WrkLinks;
 int WrkLinksCounter;

 Dlg.m_Rok=2001;
 Dlg.m_PocetCD=1;
 Dlg.m_Styl=0;
 if (Dlg.DoModal()==IDOK) 
 {
	 WasChanged=true;
	 if (GamesCounter>0) {
		for(i=0;i<GamesCounter;i++) if(GameList[i].GetJmeno()==Dlg.m_Jmeno) break;
        if (i==GamesCounter) {
            GameListBox.AddString(Dlg.m_Jmeno);
            GameListBox.SelectString(-1,Dlg.m_Jmeno);
            st_Jmeno.SetWindowText(Dlg.m_Jmeno);
			CString Str;
			Str.Format("%d",Dlg.m_PocetCD);
            st_PocetCD.SetWindowText(Str);
			Str.Format("%d",Dlg.m_Rok);
			st_Rok.SetWindowText(Str);
			CGameData wrk(Dlg.m_Jmeno,Dlg.m_Rok,Dlg.m_PocetCD,Dlg.m_Komentar,Dlg.m_UStyl,
	                Dlg.m_Styl,Dlg.LinksCounter,&Dlg.Links); 
		  	st_Styl.SetWindowText(wrk.GetStyl());
			et_Komentar.SetWindowText(wrk.GetKomentar());
			wrk.GetLinks(&WrkLinks,WrkLinksCounter);
            LinksListBox.ResetContent();
            for(j=0;j<WrkLinksCounter;j++)  LinksListBox.AddString(WrkLinks[j].Jmeno);

            GamesCounter++;
            try {
             GameList.SetAtGrow(GamesCounter-1,CGameData(Dlg.m_Jmeno,Dlg.m_Rok,Dlg.m_PocetCD,Dlg.m_Komentar,Dlg.m_UStyl,
	                Dlg.m_Styl,Dlg.LinksCounter,&Dlg.Links));}
            catch (CMemoryException* e) {
		          AfxMessageBox (_T ("Chyba: Nedostatek pameti"));
		          e->Delete (); // Delete the exception object.
		          PostQuitMessage(666);}
		} else {
          CGameData wrk(Dlg.m_Jmeno,Dlg.m_Rok,Dlg.m_PocetCD,Dlg.m_Komentar,Dlg.m_UStyl,
	                Dlg.m_Styl,Dlg.LinksCounter,&Dlg.Links); 
		  GameList[i]=wrk;
		  GameListBox.SelectString(-1,Dlg.m_Jmeno);
          st_Jmeno.SetWindowText(Dlg.m_Jmeno);
		  CString Str;
		  Str.Format("%d",Dlg.m_PocetCD);
          st_PocetCD.SetWindowText(Str);	
		  Str.Format("%d",Dlg.m_Rok);
		  st_Rok.SetWindowText(Str);
          st_Styl.SetWindowText(wrk.GetStyl());
		  et_Komentar.SetWindowText(wrk.GetKomentar());
		  wrk.GetLinks(&WrkLinks,WrkLinksCounter);
          LinksListBox.ResetContent();
          for(j=0;j<WrkLinksCounter;j++)  LinksListBox.AddString(WrkLinks[j].Jmeno);

		}
	 } else {
            GameListBox.AddString(Dlg.m_Jmeno);
            GameListBox.SelectString(-1,Dlg.m_Jmeno);
            st_Jmeno.SetWindowText(Dlg.m_Jmeno);
			CString Str;
			Str.Format("%d",Dlg.m_PocetCD);
            st_PocetCD.SetWindowText(Str);
			Str.Format("%d",Dlg.m_Rok);
			st_Rok.SetWindowText(Str);
			CGameData wrk(Dlg.m_Jmeno,Dlg.m_Rok,Dlg.m_PocetCD,Dlg.m_Komentar,Dlg.m_UStyl,
	                Dlg.m_Styl,Dlg.LinksCounter,&Dlg.Links); 
		  	st_Styl.SetWindowText(wrk.GetStyl());
			et_Komentar.SetWindowText(wrk.GetKomentar());
			wrk.GetLinks(&WrkLinks,WrkLinksCounter);
            LinksListBox.ResetContent();
            for(j=0;j<WrkLinksCounter;j++)  LinksListBox.AddString(WrkLinks[j].Jmeno);
            GamesCounter++;
            try {
             GameList.SetAtGrow(GamesCounter-1,CGameData(Dlg.m_Jmeno,Dlg.m_Rok,Dlg.m_PocetCD,Dlg.m_Komentar,Dlg.m_UStyl,
	                Dlg.m_Styl,Dlg.LinksCounter,&Dlg.Links));}
            catch (CMemoryException* e) {
		          AfxMessageBox (_T ("Chyba: Nedostatek pameti"));
		          e->Delete (); // Delete the exception object.
		          PostQuitMessage(666);}
	 }

 }

}

afx_msg void CChildView::OnLBNSelChange()
{
 int CurSelection;
 int i,j;
 CString Wrk;
 CArray<CLink,CLink&> WrkLinks;
 int WrkLinksCounter;
 CurSelection=GameListBox.GetCurSel();
 GameListBox.GetText(CurSelection,Wrk);
 st_Jmeno.SetWindowText(Wrk);
 for(i=0;i<GamesCounter;i++) if(GameList[i].GetJmeno()==Wrk) break;
 if (i==GamesCounter) MessageBox("Vnitrni chyba programu volejte programatora :0)");
 Wrk.Format("%d",GameList[i].GetPocetCD());
 st_PocetCD.SetWindowText(Wrk);
 Wrk.Format("%d",GameList[i].GetRok());
 st_Rok.SetWindowText(Wrk);
 st_Styl.SetWindowText(GameList[i].GetStyl());
 et_Komentar.SetWindowText(GameList[i].GetKomentar());
 GameList[i].GetLinks(&WrkLinks,WrkLinksCounter);
 LinksListBox.ResetContent();
 for(j=0;j<WrkLinksCounter;j++)  LinksListBox.AddString(WrkLinks[j].Jmeno);
}

void CChildView::OnEdititem() 
{
	// TODO: Add your command handler code here
 int CurSelection,i,j;
 CArray<CLink,CLink&> WrkLinks;
 int WrkLinksCounter;
 
 CurSelection=GameListBox.GetCurSel();
 if (CurSelection!=LB_ERR) {
	CString Wrk;
	CString OldName;
    GameListBox.GetText(CurSelection,Wrk);
	for(i=0;i<GamesCounter;i++) if (GameList[i].GetJmeno()==Wrk) break;
	if (i==GamesCounter) MessageBox("Vnitrni chyba programu volejte programatora :-()");
    CGameDialog Dlg;
    Dlg.m_Jmeno=GameList[i].GetJmeno();
	OldName=Dlg.m_Jmeno;
	Dlg.m_Rok=GameList[i].GetRok();
	Dlg.m_PocetCD=GameList[i].GetPocetCD();
	Dlg.m_Styl=GameList[i].GetStylInt();
    Dlg.m_UStyl=GameList[i].GetUStyl();
	Dlg.m_Komentar=GameList[i].GetKomentar();
	GameList[i].GetLinks(&WrkLinks,WrkLinksCounter);
	try {Dlg.Links.Copy(WrkLinks);}
    catch (CMemoryException* e) {
	       AfxMessageBox (_T ("Chyba: Nedostatek pameti"));
	       e->Delete (); // Delete the exception object.
	       PostQuitMessage(666);}
	Dlg.LinksCounter=WrkLinksCounter;
    if (Dlg.DoModal()==IDOK) {
		WasChanged=true;
		CGameData prac(Dlg.m_Jmeno,Dlg.m_Rok,Dlg.m_PocetCD,Dlg.m_Komentar,Dlg.m_UStyl,
	                Dlg.m_Styl,Dlg.LinksCounter,&Dlg.Links); 
		GameList[i]=prac;	
		GameListBox.DeleteString(CurSelection);
		GameListBox.AddString(Dlg.m_Jmeno);
		GameListBox.SelectString(-1,Dlg.m_Jmeno);
        st_Jmeno.SetWindowText(Dlg.m_Jmeno);
		CString Str;
		Str.Format("%d",Dlg.m_PocetCD);
        st_PocetCD.SetWindowText(Str);	
		Str.Format("%d",Dlg.m_Rok);
		st_Rok.SetWindowText(Str);
        st_Styl.SetWindowText(prac.GetStyl());
		et_Komentar.SetWindowText(prac.GetKomentar());
		prac.GetLinks(&WrkLinks,WrkLinksCounter);
        LinksListBox.ResetContent();
        for(j=0;j<WrkLinksCounter;j++)  LinksListBox.AddString(WrkLinks[j].Jmeno);

	}
	}

}

void CChildView::OnDeleteitem() 
{
	// TODO: Add your command handler code here
 int CurSelection,i,j;
 CString wrk,msg;
 CArray<CLink,CLink&> WrkLinks;
 int WrkLinksCounter;
 
 CurSelection=GameListBox.GetCurSel();
 if (CurSelection!=LB_ERR) {
  GameListBox.GetText(CurSelection,wrk);
  msg=wrk;
  msg="Opravdu chcete smazat polozku "+msg+" ?";
  if (MessageBox(msg,"Potvrzeni",MB_YESNO)==IDYES) {
		GameListBox.DeleteString(CurSelection);
			for(i=0;i<GamesCounter;i++) if(GameList[i].GetJmeno()==wrk) break; 
			if (i==GamesCounter) MessageBox("Pozor vnitrni chyba programu");
			else {GamesCounter--;GameList.RemoveAt(i);
			if (CurSelection>0) {
            GameListBox.SetCurSel(CurSelection-1);
            GameListBox.GetText(CurSelection-1,wrk);  			
            for(i=0;i<GamesCounter;i++) if(GameList[i].GetJmeno()==wrk) break; 			
			st_Jmeno.SetWindowText(GameList[i].GetJmeno());
		    CString Str;
		    Str.Format("%d",GameList[i].GetPocetCD());
			st_PocetCD.SetWindowText(Str);	
			Str.Format("%d",GameList[i].GetRok());
			st_Rok.SetWindowText(Str);
			st_Styl.SetWindowText(GameList[i].GetStyl());
			et_Komentar.SetWindowText(GameList[i].GetKomentar());
			GameList[i].GetLinks(&WrkLinks,WrkLinksCounter);
            LinksListBox.ResetContent();
            for(j=0;j<WrkLinksCounter;j++)  LinksListBox.AddString(WrkLinks[j].Jmeno);
			}
			}
  }

 }
 	
}

void CChildView::OnNewlist() 
{
	// TODO: Add your command handler code here
	if (WasChanged) {
		CString wrk="Soubor "+OpenFile+" byl zmenen chcete ho ulozit ?";
		if (MessageBox(wrk,"potvrzeni",MB_YESNO)==IDYES)
            OnFileSave();
	}
	OpenFile="Bezejmena";
	WasChanged=false;
	HasName=false;
	GamesCounter=0;
	GameList.RemoveAll();
	GameListBox.ResetContent();
	LinksListBox.ResetContent();
	st_Jmeno.SetWindowText("");
	st_Rok.SetWindowText("");
	st_PocetCD.SetWindowText("");
    st_Styl.SetWindowText("");
	et_Komentar.SetWindowText("");
}

void CChildView::OnFileSave() 
{
	// TODO: Add your command handler code here
	CString File=OpenFile;
	if (!HasName) {
	 CString Filter ="Databaze her (*.dh)|*.dh|Vsechny Soubory (*.*)|*.*||";
	 CFileDialog Dlg(FALSE,"dh",NULL,OFN_LONGNAMES,Filter);
	 if (Dlg.DoModal()==IDOK) {
		 File=Dlg.GetFileName();
	 } else return;
	 if (!SaveGameList(File)) MessageBox("Chyba pri ukladani dat ");
	} else if (!SaveGameList(File)) MessageBox("Chyba pri ukladani dat ");
	HasName=true;
	OpenFile=File;
	WasChanged=false;
}


int CChildView::SaveGameList(CString FileName)
{
int i;
CString Sign="GameDatabase";
try {
	CFile file(FileName,CFile::modeCreate | CFile::modeWrite); 
    CArchive ar (&file, CArchive::store); 
     ar<<Sign;
     ar<<GamesCounter;
     for(i=0;i<GamesCounter;i++) GameList[i].Serialize(ar);
}

catch (CFileException* e) {
    e->ReportError ();
    e->Delete ();
	return 0;
}

catch(CMemoryException* e){
    e->ReportError ();
    e->Delete ();
	PostQuitMessage(666);
	return 0;
}

catch(CArchiveException* e){
    e->ReportError ();
    e->Delete ();
	return 0;
}

return 1;	
}


int CChildView::LoadGameList(CString FileName)
{
 int i;
 CString Sign="GameDatabase";
 try {
	CFile file(FileName,CFile::modeRead); 
    CArchive ar (&file,CArchive::load); 
     ar>>Sign;
	 if (Sign!="GameDatabase") return 0;
     ar>>GamesCounter;
	 GameList.SetSize(GamesCounter);
     for(i=0;i<GamesCounter;i++) GameList[i].Serialize(ar);
}

catch (CFileException* e) {
    e->ReportError ();
    e->Delete ();
	return 0;
}

catch(CMemoryException* e){
    e->ReportError ();
    e->Delete ();
	PostQuitMessage(666);
	return 0;
}

catch(CArchiveException* e){
    e->ReportError ();
    e->Delete ();
	return 0;
}

 return 1;
}

void CChildView::OnOpenlist() 
{
	// TODO: Add your command handler code here
 CString File="";
 CString Wrk;
 CArray<CLink,CLink&> WrkLinks;
 int WrkLinksCounter;
 
 int i,j;
 CString Filter ="Databaze her (*.dh)|*.dh|Vsechny Soubory (*.*)|*.*||";
 CFileDialog Dlg(TRUE,"dh",NULL,OFN_LONGNAMES,Filter);
 if (Dlg.DoModal()==IDOK) {
	 File=Dlg.GetFileName();
 } else return;
 if (WasChanged) {
		CString wrk="Soubor "+OpenFile+" byl zmenen chcete ho ulozit ?";
		if (MessageBox(wrk,"potvrzeni",MB_YESNO)==IDYES)
            OnFileSave();
	}
 if (!LoadGameList(File)) MessageBox("Chyba pri nacitani dat ");
 GameListBox.ResetContent();
 WasChanged=false;
 HasName=true;
 OpenFile=File;
 for(i=0;i<GamesCounter;i++) GameListBox.AddString(GameList[i].GetJmeno());
 if (GameListBox.GetCount()!=0) {GameListBox.SetCurSel(0);
 GameListBox.GetText(0,Wrk);
 st_Jmeno.SetWindowText(Wrk);
 for(i=0;i<GamesCounter;i++) if(GameList[i].GetJmeno()==Wrk) break;
 if (i==GamesCounter) MessageBox("Vnitrni chyba programu volejte programatora :0)");
 Wrk.Format("%d",GameList[i].GetPocetCD());
 st_PocetCD.SetWindowText(Wrk);
 Wrk.Format("%d",GameList[i].GetRok());
 st_Rok.SetWindowText(Wrk);
 st_Styl.SetWindowText(GameList[i].GetStyl());
 et_Komentar.SetWindowText(GameList[i].GetKomentar());
 GameList[i].GetLinks(&WrkLinks,WrkLinksCounter);
 LinksListBox.ResetContent();
 for(j=0;j<WrkLinksCounter;j++)  LinksListBox.AddString(WrkLinks[j].Jmeno);
 } else {
	 	GameListBox.ResetContent();
	LinksListBox.ResetContent();
	st_Jmeno.SetWindowText("");
	st_Rok.SetWindowText("");
	st_PocetCD.SetWindowText("");
    st_Styl.SetWindowText("");
	et_Komentar.SetWindowText("");
 }
}

void CChildView::OnSaveaslist() 
{
	// TODO: Add your command handler code here
	CString File=OpenFile;
	CString Filter ="Databaze her (*.dh)|*.dh|Vsechny Soubory (*.*)|*.*||";
	CFileDialog Dlg(FALSE,"dh",NULL,OFN_LONGNAMES,Filter);
	if (Dlg.DoModal()==IDOK) File=Dlg.GetFileName();
	   else return;
	if (!SaveGameList(File)) MessageBox("Chyba pri ukladani dat ");
	 else if (!SaveGameList(File)) MessageBox("Chyba pri ukladani dat ");
	HasName=true;
	OpenFile=File;
    WasChanged=false;

}
	


void CChildView::OnFinditem() 
{
	// TODO: Add your command handler code here
 CInputDialog Dlg;
 int index,i,j;
 CString Wrk;
 CArray<CLink,CLink&> WrkLinks;
 int WrkLinksCounter;

 if (Dlg.DoModal()==IDOK) {
 Wrk=Dlg.m_Jmeno;
 if ((index=GameListBox.FindString(-1,Wrk))==LB_ERR) MessageBox("Zadna polozka zadaneho jmena nenalezena.");
 else {GameListBox.SetCurSel(index);
 GameListBox.GetText(index,Wrk);
 st_Jmeno.SetWindowText(Wrk);
 for(i=0;i<GamesCounter;i++) if(GameList[i].GetJmeno()==Wrk) break;
 if (i==GamesCounter) MessageBox("Vnitrni chyba programu volejte programatora :0)");
 Wrk.Format("%d",GameList[i].GetPocetCD());
 st_PocetCD.SetWindowText(Wrk);
 Wrk.Format("%d",GameList[i].GetRok());
 st_Rok.SetWindowText(Wrk);
 st_Styl.SetWindowText(GameList[i].GetStyl());
 et_Komentar.SetWindowText(GameList[i].GetKomentar());
 GameList[i].GetLinks(&WrkLinks,WrkLinksCounter);
 LinksListBox.ResetContent();
 for(j=0;j<WrkLinksCounter;j++)  LinksListBox.AddString(WrkLinks[j].Jmeno);

 }
 }
 }

void CChildView::OnExport() 
{
	// TODO: Add your command handler code here
CString File,Wrk;
int i,j,WorkCounter;
CStdioFile f;
CString Buffer;

CString Filter ="Textovy soubor (*.txt)|*.txt| HTML Dokument (*.html)|*.html||";
CFileDialog Dlg(FALSE,"txt",NULL,OFN_LONGNAMES,Filter);
if (Dlg.DoModal()==IDOK) {File=Dlg.GetFileName();
WorkCounter=GameListBox.GetCount();
if (Dlg.GetFileExt()=="txt") {
	if( !f.Open( File, CFile::modeCreate | CFile::modeWrite | CFile::typeText ) )  {MessageBox("Nemuzu otevrit soubor");return;}		
	f.WriteString("Jmeno hry:                   Rok vyroby Pocet CD   Styl Hry\n");
	for(i=0;i<WorkCounter;i++) {
		GameListBox.GetText(i,Wrk);
		for(j=0;j<GamesCounter;j++) if (GameList[j].GetJmeno()==Wrk) break;
        Buffer.Format("%-30s   %d    %d         %s\n",GameList[j].GetJmeno(),GameList[j].GetRok(),GameList[j].GetPocetCD(),GameList[j].GetStyl());
		f.WriteString(Buffer);
		}
} else {
 if( !f.Open( File, CFile::modeCreate | CFile::modeWrite | CFile::typeText ) )  {MessageBox("Nemuzu otevrit soubor");return;}		
 f.WriteString("<html>\n");
 f.WriteString("<head>\n");
 f.WriteString("<title>Seznam her</title>\n");
 f.WriteString("</head>\n");
 f.WriteString("<body>\n");
 f.WriteString("<h1 align=center >Seznam her</h2>");
 f.WriteString("<p align=center>\n");
 f.WriteString("<table border>\n");
 f.WriteString("<tr><th>Jmeno hry<th>Rok Vyroby<th>Pocet CD<th>Styl hry\n");
 for(i=0;i<WorkCounter;i++) {
		GameListBox.GetText(i,Wrk);
		for(j=0;j<GamesCounter;j++) if (GameList[j].GetJmeno()==Wrk) break;
		Buffer.Format("<tr><th>%-30s<th>&nbsp;%d<th>&nbsp;%d<th>%s\n",GameList[j].GetJmeno(),GameList[j].GetRok(),GameList[j].GetPocetCD(),GameList[j].GetStyl());
		f.WriteString(Buffer);
		
 } 
    
 f.WriteString("</table>\n");
 f.WriteString("</p>\n");
 f.WriteString("</body>\n");
 f.WriteString("</html>\n");
}
}else return;
	
}


void CChildView::OnGotoURL()
{
 HINSTANCE hResult;
 int CurSelection,index,i,j;
 CArray<CLink,CLink&> WrkLinks;
 int WrkLinksCounter;

 CurSelection=GameListBox.GetCurSel();
 if (CurSelection!=LB_ERR) {
 CString Wrk;
 GameListBox.GetText(CurSelection,Wrk);
 for(i=0;i<GamesCounter;i++) if (GameList[i].GetJmeno()==Wrk) break;
 if (i==GamesCounter) MessageBox("Vnitrni chyba programu volejte programatora :-()");
 GameList[i].GetLinks(&WrkLinks,WrkLinksCounter);
 index=LinksListBox.GetCurSel();
 if (index!=LB_ERR) {
 LinksListBox.GetText(index,Wrk);
 for(j=0;j<WrkLinksCounter;j++) if (WrkLinks[j].Jmeno==Wrk) break; 
 if (j==WrkLinksCounter) MessageBox("Vnitrni chyba programu");
    else hResult = ::ShellExecute( this->GetSafeHwnd(), "open", WrkLinks[j].Adresa, NULL, NULL, SW_SHOWNORMAL );
 }
 }
}

void CChildView::OnPrint() 
{
	// TODO: Add your command handler code here
CDC dc;
CFont tst;
CPrintDialog dlg (FALSE);
TEXTMETRIC tm;
int cxChar,cyChar;
int i,j,WorkCounter,CurPage=1;
CString wrk;
bool PrintSuccess=true;

tst.CreateFont(0,0,0,0,0,0,0,0,DEFAULT_CHARSET,0,0,0,FIXED_PITCH,NULL);
if (dlg.DoModal () == IDOK) {
	dc.Attach (dlg.GetPrinterDC ());    
DOCINFO di;
::ZeroMemory (&di, sizeof (DOCINFO));
di.cbSize = sizeof (DOCINFO);
di.lpszDocName = _T ("Seznam her");
dc.StartDoc (&di);
WorkCounter=GameListBox.GetCount();
dc.StartPage ();
dc.SelectObject(tst);
dc.GetTextMetrics(&tm);
cxChar=tm.tmMaxCharWidth;
cyChar=tm.tmHeight+tm.tmExternalLeading;
dc.TextOut(120,60,"Nazev hry");
dc.TextOut(120+31*cxChar,60,"Rok");
dc.TextOut(120+36*cxChar,60,"CD");
dc.TextOut(120+39*cxChar,60,"Styl hry");

for(i=0;i<WorkCounter;i++) {
		GameListBox.GetText(i,wrk);
        if ((i+1)>(CurPage*55)) {
			if (dc.EndPage()<=0) {PrintSuccess=false;break;}
			dc.StartPage();
			dc.SelectObject(tst);
            dc.GetTextMetrics(&tm);
            cxChar=tm.tmMaxCharWidth;
            cyChar=tm.tmHeight+tm.tmExternalLeading;
			CurPage++;}
		for(j=0;j<GamesCounter;j++) if (GameList[j].GetJmeno()==wrk) break;
		dc.TextOut(120,120+(i-((CurPage-1)*55))*cyChar,GameList[j].GetJmeno());
		wrk.Format("%d",GameList[j].GetRok());
		dc.TextOut(120+31*cxChar,120+(i-((CurPage-1)*55))*cyChar,wrk);
		wrk.Format("%d",GameList[j].GetPocetCD());
		dc.TextOut(120+36*cxChar,120+(i-((CurPage-1)*55))*cyChar,wrk);
        dc.TextOut(120+39*cxChar,120+(i-((CurPage-1)*55))*cyChar,GameList[j].GetStyl());
        }

if (PrintSuccess) if (dc.EndPage ()<=0) dc.AbortDoc(); else dc.EndDoc();
    else dc.AbortDoc();
}
}
